UNIT		Nya;

INTERFACE

VAR		timer			:	LONGINT ABSOLUTE $0040:$006C;
			clocktemp	:	LONGINT;

PROCEDURE PutKey(Chr : CHAR);
PROCEDURE PrintStr(Str : STRING);
PROCEDURE PrintStrLn(Message : STRING);
PROCEDURE Pr(Msg : STRING);
PROCEDURE Print(Message : STRING);
PROCEDURE PrintLn(Message : STRING);
PROCEDURE Tsr(rc : BYTE);
PROCEDURE XGetTime(VAR hour, mins, secs, hund : WORD);
PROCEDURE SetVector(int : BYTE; errupt : POINTER);
PROCEDURE GetVector(int : BYTE; VAR errupt : POINTER);
FUNCTION  UCase(Tkn : CHAR) : CHAR;
FUNCTION  UCaseStr(T : STRING) : STRING;
PROCEDURE FlushKbd;
FUNCTION  KeyHit : BOOLEAN;
FUNCTION  WaitKey : CHAR;
FUNCTION  GetKey(VAR key: WORD): BOOLEAN;
FUNCTION  Instr(Objct, Target: STRING; StartPos: BYTE): BYTE;
FUNCTION  FileExist(filename : STRING) : BOOLEAN;
FUNCTION  DisableDrive(drv : BYTE) : BOOLEAN;
FUNCTION  EnableDrive(drv : BYTE) : BOOLEAN;
PROCEDURE GetDisks(VAR disks : BYTE);
PROCEDURE Buzz(freq : WORD);
PROCEDURE Quiet;
PROCEDURE Wait(t : LONGINT);

IMPLEMENTATION

PROCEDURE PutKey(Chr : CHAR); ASSEMBLER;
	ASM
		MOV	AH, 05h				{ Funktionen STORE KEYSTROKE IN KEYBOARD BUFFER }
		MOV	CH, 00h				{ Scancode fr tangenten, 00h fungerar bra, }
		MOV	CL, BYTE(Chr)		{ d anvnds bara ASCII koden }
		INT	16h
	END;

PROCEDURE PrintStr(Str : STRING); ASSEMBLER;
	ASM
		PUSH	DS
		LDS	SI, Str
		CLD
		LODSB
		XOR	AH, AH
		XCHG	AX, CX			{ Antal tecken att skriva }
		MOV	AH, 40h			{ Write to File or Device }
		MOV	BX, 1				{ StdOut file handle }
		MOV	DX, SI
		INT	21h
		POP	DS
	END;

PROCEDURE PrintStrLn(Message : STRING);
BEGIN
	PrintStr(Message + #13#10);
END;

PROCEDURE Pr(Msg : STRING); ASSEMBLER;	{ $-terminerad strng }
	ASM
		LDS	DX, Msg
		INC	DX					{ Frsta tecknet i en STRING r storleken }
		MOV	AH, 09h			{ Display String DS:DX Pekar p strngen}
		INT	21h
	END;

PROCEDURE Print(Message : STRING);
BEGIN
	Pr(Message + '$');
END;

PROCEDURE PrintLn(Message : STRING);
BEGIN
	Pr(Message + #13#10'$');
END;

PROCEDURE Tsr(rc : BYTE); ASSEMBLER;
	ASM
		MOV	AX, [SYSTEM.PREFIXSEG]
		MOV	ES, AX
		MOV	DX, ES:[0002h]
		SUB	DX, AX				{ antal paragrafer (1 paragraf = 16 bytes) }
		MOV	AL, rc				{ exitcode }
		MOV	AH, 31h				{ Keep Process }
		INT	21h
		NOP
	END;

PROCEDURE XGetTime(VAR hour, mins, secs, hund : WORD); ASSEMBLER;
	ASM
		MOV	AH, 2Ch
		INT	21h
		MOV	AX, CX
		AND	AX, $FF00
		SHR	AX, 8
		LES	DI, hour
		MOV	WORD PTR ES:[DI], AX
		MOV	AX, CX
		AND	AX, $00FF
		LES	DI, mins
		MOV	WORD PTR ES:[DI], AX
		MOV	AX, DX
		AND	AX, $FF00
		SHR	AX, 8
		LES	DI, secs
		MOV	WORD PTR ES:[DI], AX
		MOV	AX, DX
		AND	AX, $00FF
		LES	DI, hund
		MOV	WORD PTR ES:[DI], AX
	END;

PROCEDURE SetVector(int : BYTE; errupt : POINTER); ASSEMBLER;
	ASM
		PUSH	DS
		LDS	SI, errupt
		MOV	AH, $25
		MOV	AL, int
		MOV	DX, SI
		INT	$21
		POP	DS
	END;

PROCEDURE GetVector(int : BYTE; VAR errupt : POINTER); ASSEMBLER;
	ASM
		MOV	AH, $35
		MOV	AL, [int]
		INT	$21
		MOV	AX, ES
		LES	DI, [errupt]
		CLD
		XCHG	BX, AX
		STOSW
		XCHG	BX, AX
		STOSW
	END;

FUNCTION UCase(Tkn : Char) : Char; ASSEMBLER;
	ASM
		MOV	AH, 65h			{ COUNTRY-DEPENDENT CHARACTER CAPITALIZATION }
		MOV	AL, 20h			{ SINGLE CHARACTER }
		MOV	DL, BYTE(Tkn)
		INT	21h
		MOV	AL, DL
	END;

FUNCTION UCaseStrA(S : STRING) : STRING; ASSEMBLER;
	ASM
		PUSH	DS								{ Spara DS }
		MOV	AH, 65h						{ COUNTRY-DEPENDENT CHARACTER CAPITALIZATION }
		MOV	AL, 21h						{ OF LENGTH SPECIFIED STRING }
		LDS	DX, [s]	  					{ Pekare till temp. strng i DS:DX }
		XOR	CH, CH						{ Tm CH }
		MOV	CL, DS:[DI]					{ Strngens lngd }
		PUSH	CX
		INC	DX								{ Positionen till frsta tecknet }
		INT	21h
		MOV	SI, DX
		LES	DI, DWORD PTR [BP + 10]	{ ES:DI pekar p returstrngen }
		POP	CX
		MOV	ES:[DI], CL					{ Stt Retur Lngd }
		JCXZ	@@Sluta						{ Hoppa framt om noll }
		INC	DI								{ ka pekaren }
		REP	MOVSB							{ Kopiera till strng }
@@Sluta:
		POP	DS								{ terstll DS }
	END;

FUNCTION UCaseStr(T : STRING) : STRING;
	BEGIN
		UCaseStr := UCaseStrA(T);
	END;

PROCEDURE FlushKbd; ASSEMBLER;
	ASM
	@1:
		MOV	AH,06h
		MOV	DL,0FFh
		INT	21h
		JNZ	@1
	END;

FUNCTION KeyHit : Boolean; ASSEMBLER;
	ASM
		MOV	BX,$0040;
		MOV	ES,BX
		MOV	AX,ES:[$001C]
		SUB	AX,ES:[$001A]
	END;

FUNCTION WaitKey : CHAR; ASSEMBLER;
	ASM
		MOV	AH, 08h		{ Read Keyboard, No Echo, Ctrl-C Check }
		INT	21h
	END;

FUNCTION GetKey(VAR key: WORD): BOOLEAN; ASSEMBLER;
	ASM
		LES	DI, key
		MOV	WORD PTR ES:[DI], 0000h
		MOV	AH, 1
		INT	16h
		MOV	AL, 0
		JE		@@1
		XOR	AH, AH
		INT	16h
		LES	DI, key
		MOV	WORD PTR ES:[DI],AX
		MOV	AL, 1
	@@1:
	END;

FUNCTION Instr(Objct, Target: STRING; StartPos: BYTE): BYTE; ASSEMBLER;
ASM
{$IFOPT G+}
			  PUSH    BP            { save frame pointer }
{$ENDIF}
			  CLD                   { auto increment for string instructions }
           PUSH    DS            { save Turbo Pascal's data segment }
           LES     DI, [Target]  { pointer to target string }
           LDS     SI, [Objct]   { pointer to object string }
           XOR     BX, BX        { initialize }
           OR      BL, [StartPos]{  start position }
           JZ      @NoChange     { don't change when zero }
           DEC     BX            { dekrement start position }
@NoChange: LODSW                 { AL = length Object, AH = 1. char in Object }
           SUB     AL, 1         { length Object - 1 }
           JB      @NotFound1    { exit, if length-1 < 0 }
           MOV     CL, ES: [DI]  { length target String }
           MOV     CH, CL        { length traget String }
			  SUB     CL, AL        { length target - length Object + 1 }
			  JBE     @NotFound1    { if <= 0, exit }
			  SUB     CL, BL        { remaining length Target }
			  JBE     @NotFound1    { if <= 0, exit }
           INC     DI            { 1. char in Target }
			  ADD     DI, BX        { start position in Target }
			  XCHG    CH, BH        { BH = length target string, CH = 0 }
			  XCHG    AL, AH        { AL = 1. char Object, AH = length Object }
           MOV     BP, SI        { save pointer }
@Search1:  REPNZ   SCASB         { scan target for 1st char of Object }
           JNZ     @NotFound2    { if not found, exit }
           MOV     BL, CL        { save remaining length target }
           MOV     CL, AH        { char still to compare in Object }
           MOV     DX, DI        { get offset into Target }
           REPZ    CMPSB         { compare CX chars of Target and Object }
           MOV     SI, BP        { offset into Object }
			  MOV     DI, DX        { offset into Target }
			  MOV     CL, BL        { remaining length Target }
			  JNZ     @Search1      { continue search if no complete match }
			  SUB     BH, BL        { pos = length Target - remaining len target}
			  SUB     BH, AH        { pos = l. Target - rem. l. target - l. Object}
@NotFound1:MOV     CH, BH        { pos }
@NotFound2:MOV     AL, CH        { pos }
			  XOR     AH, AH        { clear MSB }
			  POP     DS            { restore TURBO Pascal's data segment }
{$IFOPT G+}
			  POP     BP            { restore frame pointer }
{$ENDIF}
END; { Instr }

FUNCTION FileExist(filename : STRING) : BOOLEAN; ASSEMBLER;
	ASM
		PUSH   DS
		LDS    SI, [filename]      { make ASCIIZ }
		XOR    AH, AH
		LODSB
		XCHG   AX, BX
		MOV    Byte Ptr [SI+BX], 0
		MOV    DX, SI
		MOV    AX, 4300h           { get file attributes }
		INT    21h
		MOV    AL, False
		JC     @1                  { fail? }
		INC    AX
	@1:
		POP    DS
	END;

FUNCTION DisableDrive(drv : BYTE) : BOOLEAN; ASSEMBLER;
	ASM
		MOV	AX, 5F08h		{ Disable Drive }
		MOV	DL, drv			{ *** OBS! *** A: = 0, B: = 1 osv }
		INT	21h				{ Starta funktionen }
		JC		@1					{ Fel }
		MOV	AL, 1				{ DisableDrive() = True }
		JMP	@2
	@1:
		MOV	AL, 0				{ DisableDrive() = False }
	@2:
	END;

FUNCTION EnableDrive(drv : BYTE) : BOOLEAN; ASSEMBLER;
	ASM
		MOV	AX, 5F07h		{ Enable Drive }
		MOV	DL, drv			{ *** OBS! *** A: = 0, B: = 1 osv }
		INT	21h				{ Starta funktionen }
		JC		@1					{ Fel }
		MOV	AL, 1				{ DisableDrive() = True }
		JMP	@2
	@1:
		MOV	AL, 0				{ DisableDrive() = False }
	@2:
	END;

PROCEDURE GetDisks(VAR disks : BYTE); ASSEMBLER;
	ASM
		MOV	AX, 0e00h	{Select Disk}
		MOV	DL, 2			{Drive C}
		INT	21h
		LES	DI, disks
		MOV	BYTE PTR ES:[DI], AL
	END;

PROCEDURE Buzz(freq : WORD); ASSEMBLER;
	ASM
		MOV	BX,[freq]
		MOV	AX,$34DD
		MOV	DX,$0012
		CMP	DX,BX
		JNB	@1
		DIV	BX
		MOV	BX,AX
		IN		AL,$61
		TEST	AL,$03
		JNE	@2
		OR		AL,$03
		OUT	$61,AL
		MOV	AL,$B6
		OUT	$43,AL
	@2:
		MOV	AL,BL
		OUT	$42,AL
		MOV	AL,BH
		OUT	$42,AL
	@1:
	END;

PROCEDURE Quiet; ASSEMBLER;
	ASM
		IN		AL,$61
		AND	AL,$FC
		OUT	$61,AL
	END;

FUNCTION Clock: LONGINT; ASSEMBLER;
	ASM
		PUSH    DS              { save caller's data segment }
		MOV     DS, Seg0040     {  access ticker counter }
		MOV     BX, 6Ch         { offset of ticker counter in segm.}
		MOV     DX, 43h         { timer chip control port }
		MOV     AL, 4           { freeze timer 0 }
		PUSHF                   { save caller's int flag setting }
		CLI                     { make reading counter an atomic operation}
		MOV     DI, DS:[BX]     { read BIOS ticker counter }
		MOV     CX, DS:[BX+2]
		STI                     { enable update of ticker counter }
		OUT     DX, AL          { latch timer 0 }
		CLI                     { make reading counter an atomic operation}
		MOV     SI, DS:[BX]     { read BIOS ticker counter }
		MOV     BX, DS:[BX+2]
		IN      AL, 40h         { read latched timer 0 lo-byte }
		MOV     AH, AL          { save lo-byte }
		IN      AL, 40h         { read latched timer 0 hi-byte }
		POPF                    { restore caller's int flag }
		XCHG    AL, AH          { correct order of hi and lo }
		CMP     DI, SI          { ticker counter updated ? }
		JE      @no_update      { no }
		OR      AX, AX          { update before timer freeze ? }
		JNS     @no_update      { no }
		MOV     DI, SI          { use second }
		MOV     CX, BX          {  ticker counter }
@no_update:
		NOT     AX              { counter counts down }
		MOV     BX, 36EDh       { load multiplier }
		MUL     BX              { W1 * M }
		MOV     SI, DX          { save W1 * M (hi) }
		MOV     AX, BX          { get M }
		MUL     DI              { W2 * M }
		XCHG    BX, AX          { AX = M, BX = W2 * M (lo) }
		MOV     DI, DX          { DI = W2 * M (hi) }
		ADD     BX, SI          { accumulate }
		ADC     DI, 0           {  result }
		XOR     SI, SI          { load zero }
		MUL     CX              { W3 * M }
		ADD     AX, DI          { accumulate }
		ADC     DX, SI          {  result in DX:AX:BX }
		MOV     DH, DL          { move result }
		MOV     DL, AH          {  from DL:AX:BX }
		MOV     AH, AL          {   to }
		MOV     AL, BH          {    DX:AX:BH }
		MOV     DI, DX          { save result }
		MOV     CX, AX          {  in DI:CX }
		MOV     AX, 25110       { calculate correction }
		MUL     DX              {  factor }
		SUB     CX, DX          { subtract correction }
		SBB     DI, SI          {  factor }
		XCHG    AX, CX          { result back }
		MOV     DX, DI          {  to DX:AX }
		POP     DS              { restore caller's data segment }
	END;

PROCEDURE Wait(t : LONGINT);
BEGIN
	IF t > 0 THEN BEGIN
		clocktemp := Clock;
		WHILE (Clock - clocktemp) < t DO;
	END;
END;

PROCEDURE InitTimer;
BEGIN
	Port [$43] := $34;                { need rate generator, not square wave }
	Port [$40] := 0;                  { generator as programmed by some BIOSes }
	Port [$40] := 0;                  { for timer 0 }
END;


BEGIN
	InitTimer;
END.
