#include <iostream.h>
#include <fstream.h>
#include <dir.h>
#include <io.h>
#include <string.h>

char buffer[513];
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
int  flags;

void usage()
{
	cout << "addcr 1.01 copyright (c) 1996 Fredrik Wangel" << endl << endl
		  << "usage: addcr files" << endl << endl
		  << "  Wildcards are accepted." << endl
		  << "  Addcr adds a CR (13) character to a text file" << endl
		  << "  after each line. Outputs to stdout." << endl;
}

int process(char *input)
{
	int  i;
	char ch;
	ifstream fin;

	fin.open(input);
	if(fin.fail())
		return 1;
	while(!fin.eof())
	{
		fin.getline(buffer, 512).ignore(512, '\n');
		for(i = 0; i < strlen(buffer); i++)
			cout.put(buffer[i]);
		if(!fin.eof())
			cout.put(13).put(10);
	}
	fin.close();
	return 0;
}

int main(int argc, char *argv[])
{
	struct ffblk ffblk;
	int    done;

	argc--;
	if((!argc) || (!strcmp(argv[1], "-?")) || (!strcmp(argv[1], "/?"))
				  || (!strcmp(argv[1], "-h")) || (!strcmp(argv[1], "-H")))
	{
		usage();
		return 0;
	}
	done = findfirst(argv[1], &ffblk, 0);
	while(!done)
	{
		flags = fnsplit(ffblk.ff_name, drive, dir, file, ext);
		cerr << "processing file \"" << ffblk.ff_name << "\"." << endl;
		process(ffblk.ff_name);
		done = findnext(&ffblk);
	}
	return 0;
}
