program detabx;
uses
	nya;
type
	OutProc		=	procedure(s: string);
	string2		=	string[2];
const
	ver			:	string2 = '1';
	rev			:	string2 = '1';
	version		:	string[64] = '$VER: detabx 1.1 (26.01.96) Copyright (C)1996 Fredrik Wangel';
var
	Out,
	OutLn			:	OutProc;
	OldExit,
	int1Bsave	:	pointer;
	buf			:	array[1..32768] of char;
	fob			:	file;
	line,
	s1				:	string;
	ch				:	char;
	i,
	col,
	nr,
	tabsize		:	word;
	kod			:	integer;
	closed		:	boolean;

procedure __write(s : string);
begin
	write(s);
end;

procedure __writeln(s : string);
begin
	writeln(s);
end;

function SetDeviceRaw(var T: Text) : boolean; assembler;
{ Checks whether or not the Text file is a device.
  If so, it is forced to "raw" mode }
asm
	LES	DI,T
	MOV	BX,WORD PTR ES:[DI]
	MOV	AX,4400H
	INT	21H
	MOV	AL, 0						{ assume false }
	TEST	DX,0080H
	JZ		@@1
	OR		DL,20H
	MOV	DH,DH
	MOV	AX,4401H
	INT	21H
	MOV	AL, 1						{ it was forced to raw }
@@1:
end;

{$F+}
procedure _break_handler; interrupt;
	begin
		out('^C');
		halt(1);
	end;

{$F+}
procedure NewExitProc;
begin
	ExitProc := OldExit;
	SetVector($1B, Int1Bsave);
	if not closed then
		close(fob);
	Out(' '#13);
	FlushKbd;
	while keyhit do;
	FlushKbd;
end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	OldExit := ExitProc;
	ExitProc := @NewExitProc;
	closed := true;

	if SetDeviceRaw(output) then begin
		Out   := __write;
		OutLn := __writeln;
	end
	else begin
		Out   := PrintStr;
		OutLn := PrintStrLn;
	end;

	if ((paramcount < 1) or (pos('?', paramstr(1)) <> 0)) then begin
		outln('DeTabX v' + ver + '.' + rev + ' (C)1996 Fredrik Wangel');
		outln('Usage: DETABX textfile [tabsize]');
		outln('tabsize defaults to 3.');
		halt(1);
	end;
	if not fileexist(paramstr(1)) then begin
		outln('File "' + paramstr(1) + '" could not be found!');
		halt(2);
	end;
	if paramcount < 2 then
		tabsize := 3
	else begin
		val(paramstr(2), tabsize, kod);
		if kod <> 0 then begin
			outln('Error in TABSIZE. Must be an integer of byte size!');
			halt(4);
		end;
	end;

	assign(fob, paramstr(1));
	reset (fob, 1);
	closed := false;
	line := '';
	col  := 0;
	repeat
		BlockRead(fob, buf, sizeof(buf), nr);
		if nr > 0 then
			for i := 1 to nr do begin
				if buf[i] = #13 then
					continue
				else if buf[i] = #10 then begin
					OutLn(line);
					col := 0;
					line := '';
				end
				else if buf[i] = #9 then begin
					repeat
						line := line + ' ';
						inc (col);
					until ((col - 1) mod tabsize) = (tabsize - 1);
				end
				else begin
					line := line + buf[i];
					inc (col);
				end;
			end;
	until nr = 0;
	if col <> 0 then
		OutLn('');
	close(fob);
	closed := true;
end.
