program _DSKINFO;

{$M 65520, 0, 16384}

(* DSKINFO.PAS & DSKINFO.EXE Copyright (C)1993-1996 Fredrik Wangel *)

(*
	DskInfo 1.040 (4.2.95)   Sat  4-Feb-1995 19.10.00
	DskInfo 1.042 (2.8.95)   Wed  2-Jul-1995 20.20.00
	DskInfo 1.043 (4.10.95)  Wed  4-Oct-1995 17.51.23
	DskInfo 1.044 (1.11.95)  Wed  1-Nov-1995 20.08.00
	DskInfo 1.045 (9.1.96)   Tue  9-Jan-1996
	DskInfo 1.047 (21.2.96)
	DskInfo 1.200 (28.4.96)  Sun 28-Apr-1996 FIXED A SERIOUS BUG IN THE PARSING
*)

uses
	nya,
	dos,
	crt;
const
	verstr			:	string = '$VER: dskinfo 1.200 (28.04.96)'#13#10'Copyright (c)1993-1996 Fredrik Wangel (WaF)';
var
	int1Bsave		:	pointer;
	blsize			:	word;
	moder,
	origind,
	currd				:	string;
	axrtn,
	bxrtn,
	cxrtn,
	dxrtn				:	word;
	enhet				:	byte;
	under,
	shortinfo,
	nohead			:	boolean;
	key,
	coo				:	word;

function _fixdir(fs:string):string;
	begin
		if length(fs) > 1 then begin
			if fs[length(fs)] <> ':' then begin
				if fs[length(fs)] = '\' then
					fs := copy(fs, 1, length(fs) - 1);
				end
		end;
		_fixdir := fs;
	end;

function _chdir(cs:string) : boolean;
begin
	cs := _fixdir(cs);
	{$I-}
	chdir(cs);
	{$I+}
	_chdir := ioresult = 0;
end;

{$F+}
procedure _break_handler; interrupt;
	begin
		writeln('^C');
		setvector($1B, int1Bsave);
		_chdir(origind);
		halt(1);
	end;
{$F-}

FUNCTION punkt(l : LONGINT) : STRING;
	VAR
		s	:	STRING;
		i	:	INTEGER;
	BEGIN
		Str(l, s);
		i := Length(s) - 2;
		IF Length(s) > 3 THEN
			WHILE i > 1 DO BEGIN
				Insert('.', s, i);
				Dec(i, 3);
			END;
		punkt := s;
	END;

FUNCTION longabr(b2a : LONGINT) : STRING;
	VAR
		b2ar			:	REAL;
		b2as			:	STRING[16];
		abrstr		:	STRING[6];
	BEGIN
		b2ar := b2a;
		abrstr := ' byte';
		IF b2a > ((maxlongint div 2) - 1024*1024*8) THEN BEGIN
			b2ar := b2a / (1024 * 1024 * 1024.0);
			abrstr := 'Gb';
		END
		ELSE IF b2a > ((maxlongint div 2048) - 1024*8) THEN BEGIN
				b2ar := b2a / (1024 * 1024.0);
				abrstr := 'Mb';
			END
			ELSE IF b2a > 1023 THEN BEGIN
					b2ar := b2a / 1024.0;
					abrstr := 'Kb';
				END;
		IF b2a = 0 THEN
			longabr := '0 bytes';
		IF b2a > 0 THEN BEGIN
			IF b2a < 1024 THEN BEGIN
				b2as := punkt(b2a);
			END
			ELSE BEGIN
				if frac(b2ar) >= 0.9 then b2ar := Round(b2ar);
				Str(Round(Frac(b2ar) * 10), b2as);
				if length(b2as) > 1 then
					b2as := b2as[2];
				b2as := punkt(Round(Int(b2ar))) + b2as;
				IF abrstr = ' byte' THEN BEGIN
					IF Length(b2as) > 1 THEN
						b2as[0] := Chr(Ord(b2as[0]) - 1);
				END
				ELSE
					Insert(',', b2as, Length(b2as));
			END;
			b2as := b2as + abrstr;
			longabr := b2as;
		END;
	END;

function short(t : string ; mdl : byte) : string;
	var
		t2		:	string;
		ps,
		l		:	integer;
	begin
		l := length(t);
		if l > mdl then begin
			t[3] := #1;
			t2 := Copy(t, 4, Pos('\', t) - 3);
			repeat
				ps := Pos('\', t);
				Delete(t, 4, ps - 3);
			until (length(t) + 4 + length(t2)) <= mdl;
			t[3] := '\';
			insert(t2 + '...\', t, 4);
		end;
		short := t;
	end;

function fixpath(p : string) : string;
	begin
		fixpath := p;
		if p[length(p)] <> '\' then fixpath := p + '\';
	end;

function fixdrv(d : string) : string;
	begin
		fixdrv := d;
		if d[length(d) - 1] <> ':' then fixdrv := copy(d, 1, length(d) - 1);
	end;

function calctree(namn: string; var nof, nod, sof, bif : longint) : boolean;
var
	dirinfo	:	searchrec;
	good,
	stopit	:	boolean;
	ubl		:	real;

	procedure walktree(name: string; var di: searchrec);
	var
		ndi	:	searchrec;
	begin
		{$I-}
		Write(#13, short(name, 60));
		ClrEol;
		findfirst(name + '*.*', AnyFile, di);
		while ((doserror = 0) and (stopit = false)) do begin
			if (di.attr and directory) <> 0 then begin
				if (di.name <> '.') and (di.name <> '..') then begin
					ndi := di;
					walktree(name + di.name + '\', ndi);
				end;
			end
			else begin
				if (di.attr and volumeid) = 0 then begin
					ubl := di.size / blsize;
			if frac(ubl) <> 0.0 then
				ubl := int(ubl) + 1
			else
				ubl := int(ubl);
					if ubl = 0 then ubl := 1;
					inc(bif, round(ubl) * blsize);
					inc(sof, di.size);
					inc(nof);
				end;
			end;
			if KeyHit then begin
				GetKey(key);
				FlushKbd;
			end;
			if key = $011b then stopit := true;
			{$I-}
			findnext(di);
		end;
		if stopit = true then begin
			good := false;
		end
		else begin
			inc(nod);
		end;
	end;

	begin
		good := true;
		stopit := false;
		nof := 0;
		nod := 0;
		sof := 0;
		bif := 0;
		key := $0000;
		walktree(namn, dirinfo);
		calctree := good;
	end;

procedure _init;
var
	ti				:	byte;
	ipa			:	pathstr;
	idi			:	dirstr;
	ina			:	namestr;
	iex			:	extstr;
	xxx			:	string;
begin
	under := false;
	shortinfo := false;
	nohead := false;
	getdir(0, origind);
	moder := '';
	for ti := 1 to paramcount do begin
		if copy(paramstr(ti), 1, 2) = '/!' then begin
			writeln(copy(verstr, 7, length(verstr)));
			setvector($1B, int1Bsave);
			halt(0);
		end;
		if copy(paramstr(ti), 1, 2) = '/?' then begin
			writeln('Shows statistics on current or selected drive');
			writeln;
			writeln('Usage: DSKINFO [path] [/U] [/?]');
			writeln;
			writeln('path        The drive/path that you want examined.');
			writeln('/S          Only scan the current directory and below.');
			writeln('/T          Shows only the total size of the drive/directory tree.');
			writeln('/N          Do not display information banner.');
			writeln('/!          Displays some extra information.');
			setvector($1B, int1Bsave);
			halt(0);
		end;
		xxx := copy(paramstr(ti), 1, 2);
		if ucasestr(xxx) = '/T' then
			shortinfo := true
		else begin
			if ucasestr(xxx) = '/N' then
				nohead := true
			else begin
				if ucasestr(xxx) = '/S' then begin
					ipa := origind + '\';
					fsplit(ipa, idi, ina, iex);
					if moder = '' then
						moder := _fixdir(idi);
					under := true;
				end
				else begin
					if paramstr(ti) = '' then
						moder := _fixdir(copy(origind, 1, pos(':', origind) + 1) + '\')
					else begin
						moder := _fixdir(paramstr(ti));
						under := true;
					end;
				end;
			end;
		end;
	end;

	if moder = '' then
		moder := _fixdir(copy(origind, 1, pos(':', origind) + 1) + '\');
	moder := ucasestr(moder);
	if not _chdir(moder) then begin
		writeln('invalid directory "', moder, '"');
		setvector($1B, int1Bsave);
		_chdir(origind);
		halt(1);
	end;
	chdir(origind);
	currd := moder;
end;

procedure _main;
var
	ab,
	af,
	ark,
	abl			:	longint;
	ubl			:	real;
begin
	_init;

	if((moder[length(moder)] <> '\') and (moder[length(moder) - 1] <> ':')) then
	begin
		if moder[length(moder)] <> ':' then
			moder := fexpand(moder)
		else
		begin
			moder := moder + '.';
			chdir(moder);
			moder := fexpand(moder);
		end;
	end
	else
		if(pos('.', moder) > 0) then
			moder := fexpand(moder);
	currd := moder;

	if moder = '' then enhet := 0;
	if moder[1] in['A'..'Z'] then begin
		enhet := ord(moder[1]);
		enhet := enhet - 64;
	end
	else begin
		writeln('Illegal drive! [', moder[1], ':]');
		setvector($1B, int1Bsave);
		halt(255);
	end;
	asm
		mov	ah, 36h
		mov	dl, enhet
		int	21h
		mov	[axrtn], ax
		mov	[bxrtn], bx
		mov	[cxrtn], cx
		mov	[dxrtn], dx
	end;
	if axrtn = $ffff then begin
		writeln('Illegal drive!');
		setvector($1B, int1Bsave);
		halt(255);
	end;
	blsize := axrtn * cxrtn;

	abl := 0;
	ab  := 0;
	af  := 0;
	ark := 0;

	if not calctree(fixpath(currd), af, ark, ab, abl) then begin
		writeln('');
		writeln('***Aborted');
		setvector($1B, int1Bsave);
		_chdir(origind);
		halt(1);
	end;

	gotoxy(1, wherey);
	clreol;
	if nohead = false then begin
		case under of
			false:	writeln('STATISTICS ON DRIVE ' + moder[1] + ':');
			true:		begin
							writeln('STATISTICS ON DIRECTORY "' + short(moder, 30) + '"');
							if ark <> 0 then writeln('AND ALL ITS SUBDIRECTORIES');
						end;
		end;
	end;
	if shortinfo = false then begin
		writeln('                       Number of files: ', punkt(af):14);
		writeln('              Number of subdirectories: ', punkt(ark):14);
		writeln('       Total number of blocks in files: ', punkt(abl div blsize):14);
		writeln('           Bytes in use by directories: ', punkt(ark * blsize):14);
		writeln('        Total number of bytes in files: ', punkt(ab):14, ' (', longabr(ab), ')');
		writeln(' Number of bytes files take up on disk: ', punkt((abl div blsize) * blsize):14, ' (',
																			 longabr((abl div blsize) * blsize), ')');
		writeln('        Total amount of bytes on drive: ', punkt(disksize(0)):14, ' (', longabr(disksize(0)), ')');
		writeln('         Amount of bytes used on drive: ', punkt(disksize(0) - diskfree(0)):14,
																			  ' (', longabr(disksize(0) - diskfree(0)), ') [',
																			  ((((disksize(0) - diskfree(0)) / disksize(0)) * 100)):3:2, '%]');
		writeln('         Number of free bytes on drive: ', punkt(diskfree(0)):14, ' (', longabr(diskfree(0)), ') [',
																			  (((diskfree(0) / disksize(0)) * 100)):3:2, '%]');
		writeln('');
		writeln('TECHNICAL DATA:');
		writeln('  Number of sectors per allocated unit: ', punkt(axrtn):14);
		writeln('                      Bytes per sector: ', punkt(cxrtn):14, ' (', longabr(cxrtn), ')');
		writeln('             Bytes per allocated block: ', punkt(blsize):14, ' (', longabr(blsize), ')');
		writeln('');
	end
	else begin
		write  ('Total: ', punkt((abl div blsize) * blsize), ' (', longabr((abl div blsize) * blsize), ')  [');
		writeln(punkt(ab), ' (', longabr(ab), ') in the files]');
	end;
	_chdir(origind);
end;


BEGIN
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	_main;
	setvector($1B, int1Bsave);
END.
