PROGRAM Fredriks_Split_and_Join;

(* Copyright (c)1995 Fredrik Wangel *)
(* Version 1.00 (7.7.95)            *)

USES
	nya,
	DOS;

CONST
	ver				:	string[2] = '1';
	rev				:	string[2] = '0';
	version			:	string[64] = '$VER: fsploin 1.0 (7.7.95) Copyright (C)1995 Fredrik Wangel';
	hexchars			:	ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
	NO_OP				=	0;
	SPLIT				=	1;
	JOIN				=	2;
	NO_SPLIT			=	0;
	EQUAL				=	1;
	FIXED				=	2;

VAR
	infile,
	outfile			:	FILE;

	fef				:	FILE OF BYTE;

	nomore,
	broken			:	BOOLEAN;

	pbuf,
	Int1B				:	POINTER;

	res,
	res2,
	filattr			:	WORD;

	stype,
	operation		:	BYTE;

	code				:	INTEGER;

	filer,
	trash,
	sizeperchunk,
	ls,
	ts,
	storlek,
	chunks,
	i,
	pc,
	orig_size,
	total,
	readd,
	count,
	buffer_size		:	LONGINT;

	file_size		:	ARRAY [1..256] OF LONGINT;

	out_file			:	ARRAY [1..256] OF STRING[12];

	s					:	STRING;

	tp,
	orig_path		:	PATHSTR;

	destination,
	orig_dir			:	DIRSTR;

	orig_name		:	NAMESTR;

	orig_ext			:	EXTSTR;

PROCEDURE BreakHandler; INTERRUPT;
	BEGIN
		broken := TRUE;
	END;
function _word2hex(wth: word) : string;
	begin
		_word2hex := hexchars[Hi(wth) shr 4] + hexchars[Hi(wth) and $F] +
						 hexchars[Lo(wth) shr 4] + hexchars[Lo(wth) and $F];
	end;
PROCEDURE _conditions;
	BEGIN
		WRITELN;
		WRITELN('FSploin is freeware. You may redistribute, copy, or erase it as wish as');
		WRITELN('long as you do NOT change it in any way. Sourcecode is available in Borland');
		WRITELN('Pascal from me at: Fredrik Wangel, Svedjevgen 157, 394 71 Kalmar, Sweden.');
		WRITELN;
		WRITELN('This program may NOT be included in any comercial softwarepackages such as');
		WRITELN('CD-ROM compilations without a written permission from the author. (se above)');
	END;
PROCEDURE _usage_short;
	BEGIN
		WRITELN;
		WRITELN('FSploin v'+ver+'.'+rev+'   Copyright (c)1995 Fredrik Wangel');
		WRITELN('Usage: FSPLOIN <file to split or join>');
		WRITELN('               [<output directory | output file>]');
		WRITELN('               <S | J>');
		WRITELN('               [<E | F> <size of chunks | number of files>]');
		_conditions;
	END;
PROCEDURE _usage_long;
	BEGIN
		WRITELN;
		WRITELN('FSploin v'+ver+'.'+rev+'   Copyright (c)1995 Fredrik Wangel');
		WRITELN;
		WRITELN('Usage:');
		WRITELN('  Split C:\SPLIT_ME.EXE in 6 Equal sized parts and store them in D:\JOIN_US\');
		WRITELN('     FSPLOIN c:\split_me.exe d:\join_us S E 6');
		WRITELN;
		WRITELN('  Split C:\SPLIT_ME.TOO into a number of Fixed 1024 bytes chunks');
		WRITELN('     FSPLOIN c:\split_me.too S F 1024');
		WRITELN;
		WRITELN('  Join D:\JOIN_US\SPLIT_ME.* into C:\SPLIT_ME.EXE');
		WRITELN('     FSPLOIN d:\join_us\split_me c:\split_me.exe J');
		_conditions;
	END;
function _getsize(fname : pathstr): longint;
	var
		f			:	file of byte;
		fl			:	longint;
	begin
		assign(f, fname);
		reset(f);
		fl := FileSize(f);
		close(f);
		_getsize := fl;
	end;
function _fixdir(fs:string):string;
	begin
		if fs[length(fs)] <> ':' then begin
			if fs[length(fs)] <> '\' then fs := fs + '\';
		end;
		_fixdir := fs;
	end;
PROCEDURE _clean_up;
	BEGIN
		SetIntVec($1B, Int1B);
		IF broken = TRUE THEN BEGIN
			HALT(1);
		END
		ELSE BEGIN
			HALT(0);
		END;
	END;



BEGIN
	GetIntVec($1B, Int1B);
	SetIntVec($1B, Addr(BreakHandler));
	broken := FALSE;
	pc := PARAMCOUNT;
	FOR i := 1 TO pc DO BEGIN
		s := ucasestr(PARAMSTR(i));
		IF ((s = '?') OR (s = '/?') OR (s = '-?') OR (s = 'H') OR (s = '-H') OR (s = 'HELP') OR (s = '/HELP')) THEN BEGIN
			_usage_long;
			_clean_up;
		END;
	END;
	IF pc < 3 THEN BEGIN
		_usage_short;
		_clean_up;
	END;
	tp := '';
	orig_path := ucasestr(FEXPAND(PARAMSTR(1)));
	FSplit(orig_path, orig_dir, orig_name, orig_ext);
	s := ucasestr(PARAMSTR(2));
	i := 3;
	stype := NO_SPLIT;
	operation := NO_OP;
	IF ((s = 'S') OR (s = 'J')) THEN destination := orig_dir;
	IF s = 'S' THEN operation := SPLIT;
	IF s = 'J' THEN operation := JOIN;
	IF operation = NO_OP THEN tp := FEXPAND(s);
	IF operation = NO_OP THEN BEGIN
		s := ucasestr(PARAMSTR(3));
		IF s = '' THEN BEGIN
			WriteLn('S or J required');
			_clean_up;
		END;
		i := 4;
		IF s = 'S' THEN operation := SPLIT;
		IF s = 'J' THEN operation := JOIN;
		IF operation = NO_OP THEN BEGIN
			destination := FEXPAND(s);
			tp := '';
		END;
	END;
	IF operation = SPLIT THEN BEGIN
		stype := EQUAL;
		s := ucasestr(PARAMSTR(i));
		IF s = 'E' THEN BEGIN
			stype := EQUAL;
			ls := 2;
			ts := 256;
		END;
		IF s = 'F' THEN BEGIN
			stype := FIXED;
			ls := 1 + (_getsize(orig_path) div 256);
			ts := _getsize(orig_path) DIV 2;
		END;
		s := PARAMSTR(i + 1);
		IF s = '' THEN s := 'xxx';
		VAL(s, chunks, code);
		IF ((code <> 0) OR (chunks > ts) OR (chunks < ls)) THEN BEGIN
			WriteLn('Error in number');
			_clean_up;
		END;
	END;
	CASE operation OF
		SPLIT	:	Write('Splitting ');
		JOIN	:	Write('Joining ');
	END;
	IF tp <> '' THEN destination := tp;
	WriteLn(orig_path, ' to ', destination);
	writeln('');
	IF operation = JOIN THEN BEGIN
		readd := 0;
		buffer_size := 32768;
		getmem(pbuf, buffer_size);
		Assign(outfile, destination);
		Rewrite(outfile, 1);
		WriteLn('Created ', destination);
		orig_path := orig_dir + orig_name + '.';
		nomore := FALSE;
		i := 0;
		REPEAT
			s := orig_path + copy(_word2hex(i), 2, 3);
			if not fileexist(s) then
				nomore := true
			else begin
				assign(infile, s);
				reset(infile, 1);
				orig_size := _getsize(s);
				WHILE (Readd < orig_size) DO BEGIN
					count := orig_size - readd;
					IF count > buffer_Size THEN count := buffer_size;
					BlockRead(infile, pbuf^, count);
					BlockWrite(outfile, pbuf^, count);
					Inc(readd, count);
					IF broken = TRUE THEN BEGIN
						WriteLn('^C');
						Close(infile);
						Close(outfile);
						freemem(pbuf, buffer_size);
						_clean_up;
					END;
				END;
				WriteLn('Added ', s);
				close(infile);
				readd := 0;
				inc(i);
			end;
		UNTIL nomore = TRUE;
		close(outfile);
		WriteLn;
		WriteLn(destination, ' was written. (', _getsize(destination), ' bytes)');
		freemem(pbuf, buffer_size);
		WRITELN('Done.');
	END;
	IF operation = SPLIT THEN BEGIN
		filer := 0;
		destination := _fixdir(destination);
		orig_size := _getsize(orig_path);
		trash := orig_size - ((orig_size DIV chunks) * chunks);
		IF stype = FIXED THEN BEGIN
			FOR i := 0 TO (orig_size DIV chunks) DO BEGIN
				file_size[i + 1] := chunks;
				out_file[i + 1] := orig_name + '.' + copy(_word2hex(i), 2, 3);
				INC(filer);
				IF broken = TRUE THEN BEGIN
					WriteLn('^C');
					_clean_up;
				END;
			END;
			IF trash > 0 THEN BEGIN
				file_size[i + 2] := trash;
				out_file[i + 2] := orig_name + '.' + copy(_word2hex(i + 1), 2, 3);
				INC(filer);
			END;
		END;
		IF stype = EQUAL THEN BEGIN
			sizeperchunk := orig_size div chunks;
			trash := _getsize(orig_path) - (sizeperchunk * chunks);
			FOR i := 0 TO (chunks - 1) DO BEGIN
				file_size[i + 1] := sizeperchunk;
				out_file[i + 1] := orig_name + '.' + copy(_word2hex(i), 2, 3);
				INC(filer);
				IF broken = TRUE THEN BEGIN
					WriteLn('^C');
					_clean_up;
				END;
			END;
			IF trash > 0 THEN file_size[i + 1] := sizeperchunk + trash;
		END;
		Assign(infile, orig_path);
		Reset(infile, 1);
		readd := 0;
		total := 0;
		buffer_size := 65528;
		getmem(pbuf, buffer_size);
		FOR i := 0 TO (filer - 1) DO BEGIN
			Assign(outfile, destination + out_file[i + 1]);
			Rewrite(outfile, 1);
			readd := 0;
			WHILE (readd < file_size[i + 1]) DO BEGIN
				count := file_size[i + 1] - readd;
				IF count > buffer_Size THEN count := buffer_size;
				BlockRead(infile, pbuf^, count, res);
				if res < count then begin
					BlockWrite(outfile, pbuf^, res, res2);
					total := total + res;
					readd := res;
					res := 0;
					break;
				end;
				BlockWrite(outfile, pbuf^, count, res);
				readd := readd + count;
				IF broken = TRUE THEN BEGIN
					WriteLn('^C');
					Close(infile);
					Close(outfile);
					freemem(pbuf, buffer_size);
					_clean_up;
				END;
				total := total + readd;
			END;
			WriteLn(destination + out_file[i + 1], ' created. (', readd, ' bytes)');
			Close(outfile);
			if res = 0 then break;
		END;
		Close(infile);
		freemem(pbuf, buffer_size);
		writeln('Done. (', total, ' bytes written)');
	END;
	_clean_up;
END.
