program NCRPT;
uses
	crt;
type
	btyp			=	array[1..16384] of char;
const
	ver			:	string[2] = '1';
	rev			:	string[2] = '0';
	version		:	string[64] = '$VER: ncrpt 1.0 (8.9.95) Copyright (C)1995 Fredrik Wangel';
var
	s1,
	s4				:	btyp;
	source,
	destin,
	passwd		:	string;
	ch				:	char;
	fil			:	text;
	fil1,
	fil2			:	file;
	ar,
	as				:	integer;
	i,
	j,
	buffel		:	longint;
	buffer		:	btyp;

function _File_Exist(filename : string) : boolean; assembler;
asm
		  PUSH   DS
		  LDS    SI, [filename]      { make ASCIIZ }
		  XOR    AH, AH
		  LODSB
		  XCHG   AX, BX
		  MOV    Byte Ptr [SI+BX], 0
		  MOV    DX, SI
		  MOV    AX, 4300h           { get file attributes }
		  INT    21h
		  MOV    AL, False
		  JC     @1                  { fail? }
		  INC    AX
@1:     POP    DS
end;  { FileExist }

procedure _open_files;
begin
	if _file_exist(source) = true then
	begin
		assign(fil1, source);
		reset(fil1, 1);
		if _file_exist(destin) = false then
		begin
			assign(fil2, destin);
			rewrite(fil2, 1);
		end
		else
		begin
			write('File "', destin, '" exist. Overwrite? (y/N) ');
			readln(ch);
			if upcase(ch) = 'Y' then
			begin
				assign(fil2, destin);
				rewrite(fil2, 1);
			end
			else
			begin
				writeln('Aborting...');
				halt(1);
			end;
		end;
	end
	else
	begin
		writeln('File "', source, '" does not exist! Please check spelling.');
		halt(1);
	end;
end;

function sizeofb(var so : btyp) : longint;
	var
		si			:	longint;
	begin
		si := 0;
		repeat
			inc(si);
		until so[si] = #0;
		sizeofb := si - 1;
	end;

procedure encode(password : string; instring : btyp ; var outstring : btyp);
	var
		len,
		pcounter,
		scounter				:	longint;
	begin
		len := length(password) div 2;
		scounter := 1;
		pcounter := 1;
		repeat
			outstring[scounter] := chr(ord(password[pcounter]) + ord(instring[scounter]) + len);
			inc(scounter);
			inc(pcounter);
			if pcounter > length(password) then pcounter := 1;
		until scounter > buffel;
	end;

procedure decode(password : string; instring : btyp ; var outstring : btyp);
	var
		len,
		pcounter,
		scounter				:	longint;
	begin
		len := length(password) div 2;
		scounter := 1;
		pcounter := 1;
		repeat
			outstring[scounter] := chr(ord(instring[scounter]) - ord(password[pcounter]) - len);
			inc(scounter);
			inc(pcounter);
			if pcounter > length(password) then pcounter := 1;
		until scounter > buffel;
	end;

procedure _convert(t1 : btyp; var cc : btyp);
var
	it				:	longint;
begin
	for it := 1 to buffel do begin
		cc[it] := chr((($1f * it) mod $ff) - ord(t1[it]));
		cc[it] := chr(ord(cc[it]) xor it);
	end;
end;

procedure _convert2(ct1 : btyp; var cc : btyp);
var
	cit				:	longint;
begin
	for cit := 1 to buffel do
		cc[cit] := chr((($4c * cit) mod $4b) - ord(ct1[cit]) + 32);
end;

procedure empty(var e : btyp);
	var
		ei		:	longint;
	begin
		for ei := 1 to sizeofb(e) do
			e[ei] := #0;
	end;


begin
	directvideo := false;
	randomize;
	if paramcount >= 2 then
	begin
		source := paramstr(1);
		destin := paramstr(2);
		passwd := paramstr(3);
		_open_files;
		if passwd = '' then begin
			write('Enter password: ');
			repeat
				ch := readkey;
				if upcase(ch) in ['A'..'Z','0'..'9'] then begin
					passwd := passwd + ch;
					write('');
				end;
				if (ch = #8) and (length(passwd) > 0) then begin
					passwd[0] := chr(ord(passwd[0]) - 1);
					write(#8' '#8);
				end;
			until ch = #13;
			writeln;
		end;
		buffer[1] := 'C';
		buffer[2] := 'R';
		buffer[3] := 'P';
		buffer[4] := 'T';
		BlockWrite(fil2, buffer, 4);
		repeat
			empty(s1);
			empty(s4);
			empty(buffer);
			BlockRead(fil1, buffer, SizeOf(buffer), ar);
			if ar > 0 then begin
				for i := 1 to ar do s1[i] := buffer[i];
				buffel := ar;
				if passwd <> '' then begin
					encode(passwd, s1, s4);
					s1 := s4;
				end;
				empty(s4);
				_convert(s1, s4);
				empty(s1);
				_convert2(s4, s1);
				for i := 1 to ar do buffer[i] := s1[i];
				BlockWrite(fil2, buffer, ar, as);
			end;
		until (ar = 0) or (as <> ar);
		{$I-}
		close(fil1);
		close(fil2);
		{$I+}
		writeln('Done.');
	end
	else
	begin
		writeln('NCRPT v1.00 Copyright (c) 1995 WaF');
		writeln('Usage: NCRPT infile outfile [password]');
	end;
end.
